﻿
this.locationChooser = null;

this.args = parseArgs();
this.locationId = args['location_id'];
this.locationName = args['ln'];
this.landscape = args['landscape'];
this.locationPath = null;

this.homeId = null;
this.homeName = null;
this.isYoWidgetReady = false;

var addthis_config = {
    data_track_clickback: true
}

this.local = false;
try {
	local = (location.href.indexOf("file://") == 0 || location.href.indexOf("http://localhost") == 0);
}
catch(e) {
}

function parseArgs() {
    var map = new Array();
    var s = "";
    var qString;
    var pairs;

//query string
    try {
	    s = document.location.search.substring(1);
    }
    catch(e) {
    }

    qString = unescape(s);
    pairs = qString.split(/[&]/);
    for (var i in pairs) {
    	if (!pairs[i]) {
    		continue;
    	}
	    var pair = pairs[i].split(/\=/);
	    map[pair[0]] = pair[1];
    }

//hach    
    try {
	    s = document.location.hash.substring(1);
    }
    catch(e) {
    }

    qString = unescape(s);

//p    p("parseArgs(), qString=" + qString);

    pairs = qString.split(/[&]/);
    for (var i in pairs) {
    	if (!pairs[i]) {
    		continue;
    	}
	    var pair = pairs[i].split(/\=/);
	    map[pair[0]] = pair[1];
    }
    return map;
}

function onLoad(lang) {
	p("onLoad()");

	updateLandscapeRadioGroup();

	var combo = document.getElementById("timeFormat");

	var tf = this.args['tf'];
	if (tf) {
		combo.value = tf;
	}
	else {
		tf = YoUtil.getAutoTimeFormat();
		combo.value = "auto";
		combo.options[0].innerHTML = L("Auto") + " (" + (tf == 12 ?  L("AM/PM") : L("24 hours")) + ")";
	}


	installUnitChooser();
	installYoWidget(lang);

	updateQueryString();

//	debug_box.style.display = 'block';
}

function installYoWidget(lang) {
	var args = this.args;
	args['background'] = "#FFFFFF";
	if (!lang) {
		lang = getLanguageName();
	}
	args['lang'] = lang;

    var flashvars = args;
//d		trace_text_area: "1",

	if (!flashvars['location_id']) {
		flashvars['location_id'] = 'auto';
	}

	if (this.landscape) {
		flashvars['landscape'] = this.landscape;
	}


	var unitSystemId = this.unitChooser.getUnitSystemId();
//p	p("unitSystemId=" + unitSystemId);
	flashvars['us'] = unitSystemId;

    if (unitSystemId == 'custom') {
    	var system = this.unitChooser.getSystem('custom');
    	for (var aspect in system) {
    		if (aspect == 'name') {
    			continue;
    		}
    		var value = system[aspect];
    		flashvars["u_" + aspect] = value;
    	}
    }
	
	var timeFormat = getSelectedTimeFormat();
	flashvars['time_format'] = timeFormat;

    var params = {
    	quality: "high",
    	bgcolor: "#FFFFFF",
		allowscriptaccess: "always",
		allowfullscreen: "true",
		menu: "false",
		wmode: "opaque"
    };

    var attributes = {
    	id:"yowidget",
    	name:"yowidget"
    };

	YoWidget.URL = "http://swf.yowindow.com/yowidget3_infinite.swf?no_cache2=1";

	YoWidget.embed(
    	"yowidget_place", 
    	"760px", 
    	"444px",
    	flashvars,
    	params,
    	attributes
	);

}

function yowidget_onPrint(text) {
	try {
		p("[Widget] " + text);
    }
    catch (e) {
		severe("[Widget] exception: " + e);
    }
}

function yowidget_onReady() {
	try {
    	this.isYoWidgetReady = true;
    	
		reflectUnitSystemInWidget();

    	var yowidget = document.getElementById('yowidget');
    	var timeFormat = getSelectedTimeFormat();
    	yowidget.setSimpleTimeFormat(timeFormat);
    }
    catch (e) {
		severe("[Widget] onReady, exception: " + e);
    }

	var addthis = this['addthis'];
	if (addthis) {
    	addthis.init();
	}
}

function yowidget_onLocationInfoReady(locationId, name, path) {
	try {
//p p("yowindow_onLocationDetected(), locationId=" + locationId + ", name=" + name + ", path=" + path);	
		if (!this.homeId) {
        	this.homeId = locationId;
        	this.homeName = name;

    		var locationDiv = document.getElementById('location');
    		locationDiv.style.display = 'block';
    		installLocationChooser();
		}
	    
    	this.locationName = name;
    	this.locationPath = path;
     	this.locationChooser.open(path);	

    	updateHomeLink();
    	updateQueryString();

//w		selectLocation(locationId, name, path);

    }
    catch (e) {
		severe("yowidget_onLocationInfoReady(), exception: " + e);
    }
}

function installLocationChooser() {
   	var self = this;
   	var place = document.getElementById('location_chooser_place');
   	this.locationChooser = new YoLocationChooser(place);
   	this.locationChooser.onLocationChange = function(node) {
   		self.onLocationChange(node);
   	}
}

function onLocationChange(node) {
//p p("onLocationChange(), node...\n" + (node ? dump(node) : "null"));
	var locationId = node['@id'];
	if (locationId == null) {
		return;
	}
	if (locationId.indexOf(":") == -1) {
		locationId = "gn:" + locationId;
	}
	var name = node['@name'];
	var path = this.locationChooser.getPath();

//p p("before selectLocation()");
	selectLocation(locationId, name, path);
}


function installUnitChooser() {
    var unitSystemId = this.args['us'];
    if (!unitSystemId) {
	   	unitSystemId = "auto";
    }
   	
//p   	p("installUnitChooser(), unitSystemId=" + unitSystemId);
   	
   	var place = document.getElementById('unit_chooser_place');


	YoUnitChooser.basePath = "http://js.yowindow.com/js";
   	var showAutoChoice = true;
    var showExpandControl = true;
	var showUnitSystemLabel = true;
   	var uc = new YoUnitChooser(place, showAutoChoice, showExpandControl, showUnitSystemLabel);

   	if (unitSystemId == "auto") {
        var autoId = YoUtil.getAutoUnitSystem();
       	uc.setAutoUnitSystemId(autoId);
   	}
   	else {
    	var PREFIX = "u_";
       	for (var key in args) {
       		var value = args[key];
       		var index = key.indexOf(PREFIX);
       		if (index == -1) {
       			continue;
       		}
       		var aspect = key.substring(PREFIX.length);
    //p   		p("aspect=" + aspect + ", value=" + value);
            uc.setCustomAspect(aspect, value);
            unitSystemId = "custom";
       	}
	}

	uc.setUnitSystemId(unitSystemId);


   	var self = this;
   	uc.onChange = function() {
   		self.onUnitChooserChange();
   	}
   	
   	this.unitChooser = uc;
}

function onUnitChooserChange() {
    if (this.isYoWidgetReady) {
	    reflectUnitSystemInWidget();
	}
	updateQueryString();
}    

function reflectUnitSystemInWidget() {
    var unitSystemId = this.unitChooser.getUnitSystemId();
	
	var yowidget = document.getElementById('yowidget');
   	yowidget.setUnitSystem(unitSystemId);

	if (unitSystemId == 'custom') {
		var system = this.unitChooser.getSystem('custom');
		for (var aspect in system) {
			if (aspect == 'name') {
				continue;
			}
			var value = system[aspect];
    		yowidget.setUnit(aspect, value);
		}
	}
}

function selectLocation(locationId, name, path) {

	if (this.locationId == locationId) {
		return;
	}
	this.locationId = locationId;
	this.locationName = name;
	this.locationPath = path;

	if (path) {
		this.locationChooser.open(path);
	}

	if (this.isYoWidgetReady) {
    	var yowidget = document.getElementById('yowidget');

    	yowidget.setLocationId(this.locationId);
//o    	yowidget.addLocation(this.locationId);
		yowidget.setLandscape(this.landscape);
	}

	updateHomeLink();
	updateQueryString();
}

function selectLocationAndLandscape(locationId, url) {
//p p("selectLocationAndLandscape(), locaitonId=" + locationId);
	if (!url) {
		url = "village";
	}
	this.locationId = locationId;
	this.landscape = url;

//p	p("pal.setLocationId(), this.locationId="+this.locationId+"\n");
	if (this.isYoWidgetReady) {
    	var yowidget = document.getElementById('yowidget');

    	yowidget.setLocationId(locationId);
//o    	yowidget.addLocation(locationId);
    	yowidget.setLandscape(url);
	}

	updateLandscapeRadioGroup();
	updateQueryString();
}

function updateHomeLink() {
	var home = document.getElementById('home');
    if (!this.homeId 
    || this.homeId == this.locationId && this.homeName == this.locationName) {
    	home.style.display = 'none';
    	return;
    }

//p	p("this.homeId=" + this.homeId + ", this.locationId=" + this.locationId);
	
	home.href = "javascript:goHome();";
	home.style.display = 'inline';
	if (this.homeName) {
		home.innerHTML = this.homeName;
	}
	else {
		home.innerHTML = "Home";
	}	
}

function goHome() {
	this.landscape = getSelectedLandscape();
	selectLocation(this.homeId, this.homeName);
}

function updateLandscapeRadioGroup() {
	var landscape = "village";
	if (this.landscape) {
		landscape = this.landscape;
	}

	var landscapeGroup = document.forms['params'].elements['landscape'];
	for(var i = 0; i < landscapeGroup.length; i++) {
		var radioButton = landscapeGroup[i];
		var b = radioButton.id == landscape;
		radioButton.checked = b;
	}
}

function getSelectedLandscape() {
	var landscape = "village";
	if (document.getElementById('seaside').checked) {
		landscape = "seaside";
	}
	if (document.getElementById('airport').checked) {
		landscape = "airport";
	}
	if (document.getElementById('oriental').checked) {
		landscape = "oriental";
	}
	return landscape;
}

function onLandscapeChange() {	
	this.landscape = getSelectedLandscape();
//p		p("landscape=" + this.landscape);

	if (this.isYoWidgetReady) {
		var yowidget = document.getElementById('yowidget');
		yowidget.setLandscape(this.landscape);
	}

	updateQueryString();
}

function getSelectedTimeFormat() {
	var combo = document.getElementById('timeFormat');
	if (combo.value == "auto") {
		return YoUtil.getAutoTimeFormat();
	}
	return combo.value;
}

function onTimeFormatChange() {	
//p	p("onTimeFormatChange()");
	var timeFormat = getSelectedTimeFormat();
	if (this.isYoWidgetReady) {
		var yowidget = document.getElementById('yowidget');
		yowidget.setSimpleTimeFormat(timeFormat);
	}	

	updateQueryString();
}

function updateQueryString() {
//p p("updateQueryString(), this.locationName=" + this.locationName);
	var name = "";
	if (this.locationName) {
		name = this.locationName;
		if (name == "Pushkin") {
			name = "Пушкин";
		}
	}

    var pairs = [];
    var map = {};
    var qString = "";
    var queryStringMap = {};

//query string
    try {
    	qString = unescape(document.location.search.substring(1));
    }
    catch(e) {
    }
    if (qString) {
        var pairs2 = qString.split(/\&/);
        for (var i in pairs2) {
    	    var pair = pairs2[i].split(/\=/);
    	    queryStringMap[pair[0]] = pair[1];
//p			p(pair[0] + "/" + pair[1]);
        }
	}

	if (this.locationId) {
    	addPair(pairs, map, 'location_id', this.locationId);
	}
	if (name) {
		addPair(pairs, map, 'ln', name);
	}



	if (!this.unitChooser.isAutoSelected()) {
    	var unitSystemId = this.unitChooser.getUnitSystemId();
    	var customBaseSystemId = 'metric';
    	var customBaseSystem = this.unitChooser.getSystem(customBaseSystemId);

//p    	p("unitSystemId=" + unitSystemId);

        if (unitSystemId == 'custom') {
        	unitSystemId = customBaseSystemId;
        	var system = this.unitChooser.getSystem('custom');
        	for (var aspect in system) {
        		if (aspect == 'name') {
        			continue;
        		}
        		var value = system[aspect];
        		if (value != customBaseSystem[aspect]) {
        			addPair(pairs, map, "u_" + aspect, value);
        		}
        	}
        }

    	addPair(pairs, map, 'us', unitSystemId);
	}


	var combo = document.getElementById("timeFormat");
	if (combo.value != "auto") {
    	addPair(pairs, map, "tf", combo.value);
    }
    	
	var hostname = "";
	var index = -1;
	try {
		hostname = location;
		index = location.href.indexOf("?");
    	if (index != -1) {
    		hostname = top.location.href.substring(0, index);
    	}
	}
	catch(e) {
	}

	if (this.landscape) {
    	addPair(pairs, map, 'landscape', this.landscape);
	}

    var params = "";
    var hash = "";
//p    p("pairs.length=" + pairs.length);
    for (var i in pairs) {
	    var pair = pairs[i];
	    var key = pair[0];
	    var value = pair[1];

	    if (key == 'landscape' && value == 'village') {
	    	continue;
	    }

	    if (params) {
	    	params += "&";
	    }
		if (value != null) {
	    	params += key + "=" + value;
	    }

		if (queryStringMap[key] != value) {
    	    if (hash) {
    	    	hash += "&";
    	    }
    		if (value != null) {
    	    	hash += key + "=" + value;
    	    }
		}
    }
	hash = "#" + hash;

    if (document.location.hash != hash) {
//p        p("old hash=" + document.location.hash);
//        p("new hash=" + hash);
		var newLocation = location.protocol+'//'+location.host + location.pathname + location.search + hash;
//p alert("newLocation=" + newLocation);
        document.location.replace(
			newLocation
		);
    }

	var title = "YoWindow Weather";
	if (name) {
		title = name + " - " + "Weather forecast";
	}

	document.title = title;
	document.getElementById("title").innerHTML = title;

    var linkWord = document.getElementById("link_word");
    linkWord.href = "http://yowindow.com/weather?" + params;
}

function addPair(pairs, map, key, value) {
//p    p("addPair(), key=" + key + ", value=" + value);

	if (value == null || value == "") {
		return;
	}
	var pair = map[key];
	if (!pair) {
		pair = new Array(key, "");
		map[key] = pair;
		pairs.push(pair);
	}
   	pair[1] = value;
}

function getLanguageName() {
	var lang = YoUtil.getLanguage();
	var usIndex = lang.indexOf('-');
	if (usIndex != -1) {
		var dialect = lang.substring(usIndex + 1);
		if (dialect == 'at') {
		}
		else {
			lang = lang.substring(0, usIndex);
		}
	}
	return lang;
}
